-module(bignum).
-author('thijsterlouw@tencent.com').

-ifdef(TEST).
-include_lib("eunit/include/eunit.hrl").
-endif.

-behaviour(gen_linkedin_driver).

-export([start/0, start_link/0, decode/1]).
-export([driver_info/0]).

% callback
driver_info() ->
	{bignum_drv, bignum_port, bignum_table}.

start() ->
	gen_linkedin_driver:start(?MODULE).

start_link() ->
	io:format("[DRIVER] start ~p~n", [?MODULE]),
	gen_linkedin_driver:start_link(?MODULE).


%%%% API %%%%

decode(Data) when is_binary(Data) ->
	%io:format("bignum:decode: ~p \n", [Data]),
    case gen_linkedin_driver:control(?MODULE, 0, <<Data/binary, 0:8>>) of
		[] ->
			receive Any -> 
                %io:format("input len: ~p\n",[byte_size(Data)]),
                Any 
            end;
		Error ->
			io:format("====== ERROR ============~n", []),
			throw({invalid, binary_to_list(Error)})
	end;

decode(Data) when is_list(Data) ->
	decode(list_to_binary(Data)).	


-ifdef(TEST).
bignum_test_() ->
	[
		?_assertMatch(1, bignum:decode(<<"">>))
	].
-endif.
	
