-module(bignumtest).
-author('thijsterlouw@tencent.com').

% HOW TO USE: 
% 1) ./start.sh
% bignumtest:test().
% bignumtest:test_driver().

-export([test_driver/0]).

-ifdef(TEST).
-include_lib("eunit/include/eunit.hrl").
-endif.

test_driver() ->
	bignum:start(),
	A = bignum:decode(<<"4294967296">>),
	io:format("2) ~B =:= 4294967296 => ~p\n", [A, 4294967296 =:= A]).


-ifdef(TEST).
bignumtest_test_() ->
	bignum:start(),
	[
		?_assertMatch(-1125899906842624, bignum:decode(<<"-1125899906842624">>)),		
		?_assertMatch(true, -1125899906842624 =:= bignum:decode(<<"-1125899906842624">>)),		
		?_assertMatch(-4294967296, bignum:decode(<<"-4294967296">>)),
		?_assertMatch(-4294967295, bignum:decode(<<"-4294967295">>)),
		?_assertMatch(-134217728, bignum:decode(<<"-134217728">>)),	
		?_assertMatch(-134217727, bignum:decode(<<"-134217727">>)),
		?_assertMatch(-123456789, bignum:decode(<<"-123456789">>)),	
		?_assertMatch(-1, bignum:decode(<<"-1">>)),
		?_assertMatch(0, bignum:decode(<<"0">>)),
		?_assertMatch(1, bignum:decode(<<"1">>)),
		?_assertMatch(123456789, bignum:decode(<<"123456789">>)),			
		?_assertMatch(134217727, bignum:decode(<<"134217727">>)),						% 2^27 - 1
		?_assertMatch(134217728, bignum:decode(<<"134217728">>)),						% 2^27
		?_assertMatch(4294967295, bignum:decode(<<"4294967295">>)),					% 2^32 - 1
		?_assertMatch(4294967296, bignum:decode(<<"4294967296">>)),					% 2^32
		?_assertMatch(1125899906842624, bignum:decode(<<"1125899906842624">>))		% 2^50
	].
	
-endif.
	
