#!/bin/sh

WHOAMI=`whoami`
BASEDIR="$PWD"

cd $BASEDIR

EXT=""
if [ "$1" = "" ]
then
    EXT=""
else
	EXT="_$1"
fi

# get LAN address
LAN_NI=eth1
ADDR=`/sbin/ifconfig $LAN_NI | grep "inet addr" | tr : \ | awk '{print $3}'`
NODE="bignum${EXT}"
NODE_NAME="$NODE@$ADDR"

ERL_OPTS="+K true +A 30 +W w +P 180000 -pa $BASEDIR/ebin"
ERL_ARGS="$ERL_OPTS -s reloader"

###################

echo "****************START******************"
echo ${ERL_ARGS}
echo "***************************************"

exec /usr/local/bin/erl $ERL_ARGS
